//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

bool MatchAttrs(DWORD flags, DWORD attrs)
{
  return (flags & attrs) == flags;
}

bool SearchInFolder(AnsiString folder, AnsiString mask, DWORD flags,
                        TStrings * names, bool addpath = false)
{
  void * hSearch;
  WIN32_FIND_DATA * FindData = new WIN32_FIND_DATA();
  AnsiString strSearchPath;
  bool bRes; //  true,        

  strSearchPath = folder + '\\' + mask;
  bRes = false;
  // 
  hSearch = FindFirstFile(strSearchPath.c_str(), FindData);
  if (hSearch != INVALID_HANDLE_VALUE)
  {
    //    (    
    //  FindData  FindFirstFile)
    while(FindNextFile(hSearch, FindData) == true)
      if ((AnsiString(FindData->cFileName) != "..") &&
          (AnsiString(FindData->cFileName) != ".")) // .  ..
      {
        if (MatchAttrs(flags, FindData->dwFileAttributes))
        {
          //  
          if (addpath)
            names->Add(folder + '\\' + FindData->cFileName);
          else
            names->Add(FindData->cFileName);
          bRes = true;
        }
      }

    // 
    FindClose(hSearch);
  }
  return bRes;
}


//         (folder)
//        
bool SearchInTree(AnsiString folder, AnsiString mask, DWORD flags,
                      TStrings * names, bool addpath = false)
{
  void * hSearch;
  WIN32_FIND_DATA * FindData = new WIN32_FIND_DATA();
  bool bRes; //  true,        

  //    
  bRes = SearchInFolder(folder.c_str(), mask, flags, names, addpath);

  //     
  hSearch = FindFirstFile(AnsiString(folder + "\\*").c_str(), FindData);
  if (hSearch != INVALID_HANDLE_VALUE)
  {
    while(FindNextFile(hSearch, FindData) == true)
      if ((String(FindData->cFileName) != "..") &&
          (String(FindData->cFileName) != ".")) // .  ..
      {
        if (FindData->dwFileAttributes && FILE_ATTRIBUTE_DIRECTORY != 0)

          //  -    
          if (SearchInTree(folder + '\\' + String(FindData->cFileName),
                          mask, flags, names, addpath))
            bRes = true;
      }

    FindClose(hSearch);
  }
  return bRes;
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  //   (    )
  DWORD flags = 0;
  if (chkDirs->Checked) flags = flags | FILE_ATTRIBUTE_DIRECTORY;
  if (chkHidden->Checked) flags = flags | FILE_ATTRIBUTE_HIDDEN;
  if (chkSystem->Checked) flags = flags | FILE_ATTRIBUTE_SYSTEM;
  if (chkReadOnly->Checked) flags = flags | FILE_ATTRIBUTE_READONLY;
  if (chkArchive->Checked) flags = flags | FILE_ATTRIBUTE_ARCHIVE;

  lblFound->Caption = "...";
  lstFiles->Clear();
  Refresh();
  // (      )
  if (!SearchInFolder(txtFolder->Text, txtMask->Text, flags,
                        lstFiles->Items))
    lblFound->Caption = "   ";
  else
    lblFound->Caption = " : " + IntToStr(lstFiles->Count);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  //   (    )
  DWORD flags = 0;
  if (chkDirs->Checked) flags = flags | FILE_ATTRIBUTE_DIRECTORY;
  if (chkHidden->Checked) flags = flags | FILE_ATTRIBUTE_HIDDEN;
  if (chkSystem->Checked) flags = flags | FILE_ATTRIBUTE_SYSTEM;
  if (chkReadOnly->Checked) flags = flags | FILE_ATTRIBUTE_READONLY;
  if (chkArchive->Checked) flags = flags | FILE_ATTRIBUTE_ARCHIVE;

  lblFound->Caption = "->->->";
  lstFiles->Clear();
  Refresh();
  // (      )
  if (!SearchInTree(txtFolder->Text, txtMask->Text, flags,
                      lstFiles->Items, true))
    lblFound->Caption = "   ";
  else
    lblFound->Caption = " : " + IntToStr(lstFiles->Count);
}
//---------------------------------------------------------------------------
